## superlu 4.3+dfsg

=== CBLAS/Makefile ===
include ../make.inc
HEADER = ../SRC

#######################################################################
#  This is the makefile to create a library for C-BLAS.
#  The files are organized as follows:
#
#       SBLAS1 -- Single precision real BLAS routines
#       CBLAS1 -- Single precision complex BLAS routines
#       DBLAS1 -- Double precision real BLAS routines
#       ZBLAS1 -- Double precision complex BLAS routines
#
#       CB1AUX -- Real BLAS routines called by complex routines
#       ZB1AUX -- D.P. real BLAS routines called by d.p. complex
#                 routines
#
#      ALLBLAS -- Auxiliary routines for Level 2 and 3 BLAS
#
#       SBLAS2 -- Single precision real BLAS2 routines
#       CBLAS2 -- Single precision complex BLAS2 routines
#       DBLAS2 -- Double precision real BLAS2 routines
#       ZBLAS2 -- Double precision complex BLAS2 routines
#
#       SBLAS3 -- Single precision real BLAS3 routines
#       CBLAS3 -- Single precision complex BLAS3 routines
#       DBLAS3 -- Double precision real BLAS3 routines
#       ZBLAS3 -- Double precision complex BLAS3 routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  To create or add to the library, enter make
#  followed by one or more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#  The library is called
#       blas.a
#  and is created at the next higher directory level.
#
#  To remove the object files after the library is created, enter
#       make clean
#
#######################################################################

SBLAS1 = isamax.o sasum.o saxpy.o scopy.o sdot.o snrm2.o \
	 srot.o sscal.o sswap.o
SBLAS2 = sgemv.o ssymv.o strsv.o sger.o ssyr2.o

DBLAS1 = idamax.o dasum.o daxpy.o dcopy.o ddot.o dnrm2.o \
	 drot.o dscal.o dswap.o
DBLAS2 = dgemv.o dsymv.o dtrsv.o dger.o dsyr2.o

CBLAS1 = icamax.o scasum.o caxpy.o ccopy.o scnrm2.o \
	 cscal.o cswap.o
CBLAS2 = cgemv.o chemv.o ctrsv.o cgerc.o cher2.o

ZBLAS1 = izamax.o dzasum.o zaxpy.o zcopy.o dznrm2.o \
	 zscal.o dcabs1.o zswap.o
ZBLAS2 = zgemv.o zhemv.o ztrsv.o zgerc.o zher2.o


all: single double complex complex16

single: $(SBLAS1) $(SBLAS2) $(SBLAS3)
	$(ARCH) $(ARCHFLAGS) $(BLASLIB) $(SBLAS1) $(ALLBLAS) $(SBLAS2) $(SBLAS3)
	$(RANLIB) $(BLASLIB)

double: $(DBLAS1) $(DBLAS2) $(DBLAS3)
	$(ARCH) $(ARCHFLAGS) $(BLASLIB) $(DBLAS1) $(ALLBLAS) $(DBLAS2) $(DBLAS3)
	$(RANLIB) $(BLASLIB)

complex: $(CBLAS1) $(CBLAS2) $(CBLAS3)
	$(ARCH) $(ARCHFLAGS) $(BLASLIB) $(CBLAS1) $(ALLBLAS) $(CBLAS2) $(CBLAS3)
	$(RANLIB) $(BLASLIB)

complex16: $(ZBLAS1) $(ZBLAS2) $(ZBLAS3)
	$(ARCH) $(ARCHFLAGS) $(BLASLIB) $(ZBLAS1) $(ALLBLAS) $(ZBLAS2) $(ZBLAS3)
	$(RANLIB) $(BLASLIB)

.c.o:
	$(CC) $(CFLAGS) $(CDEFS) -I$(HEADER) -c $< $(VERBOSE)

clean:	
	rm -f *.o ../lib/libblas.a

=== EXAMPLE/Makefile ===
include ../make.inc

#######################################################################
#  This makefile creates the example programs for the linear equation
#  routines in SuperLU.  The files are grouped as follows:
#
#       SLINEXM -- Single precision real example routines
#       DLINEXM -- Double precision real example routines
#       CLINEXM -- Double precision complex example routines
#       ZLINEXM -- Double precision complex example routines
#
#  Example programs can be generated for all or some of the four different
#  precisions.  Enter make followed by one or more of the data types
#  desired.  Some examples:
#       make single
#       make single double
#  Alternatively, the command
#       make
#  without any arguments creates all four example programs.
#  The executable files are called
#       slinsol		slinsolx
#       dlinsol		dlinsolx
#       clinsol		clinsolx
#       zlinsol		zlinsolx
#
#  To remove the object files after the executable files have been
#  created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
#######################################################################

HEADER   = ../SRC

SLINEXM		= slinsol.o
SLINEXM1	= slinsol1.o
SLINXEXM 	= slinsolx.o
SLINXEXM1 	= slinsolx1.o
SLINXEXM2	= slinsolx2.o
SITSOL	     	= sitersol.o sfgmr.o
SITSOL1	     	= sitersol1.o sfgmr.o

DLINEXM		= dlinsol.o
DLINEXM1	= dlinsol1.o
DLINXEXM 	= dlinsolx.o
DLINXEXM1 	= dlinsolx1.o
DLINXEXM2 	= dlinsolx2.o
SUPERLUEXM 	= superlu.o sp_ienv.o
DITSOL	     	= ditersol.o dfgmr.o
DITSOL1	     	= ditersol1.o dfgmr.o

CLINEXM 	= clinsol.o
CLINEXM1 	= clinsol1.o
CLINXEXM 	= clinsolx.o
CLINXEXM1 	= clinsolx1.o
CLINXEXM2 	= clinsolx2.o
CITSOL	     	= citersol.o cfgmr.o
CITSOL1	     	= citersol1.o cfgmr.o

ZLINEXM 	= zlinsol.o
ZLINEXM1 	= zlinsol1.o
ZLINXEXM 	= zlinsolx.o
ZLINXEXM1 	= zlinsolx1.o
ZLINXEXM2 	= zlinsolx2.o
ZITSOL	     	= zitersol.o zfgmr.o
ZITSOL1	     	= zitersol1.o zfgmr.o


all:    single double complex complex16

single:    slinsol slinsol1 slinsolx slinsolx1 slinsolx2 sitersol sitersol1
double:    dlinsol dlinsol1 dlinsolx dlinsolx1 dlinsolx2 superlu \
		ditersol ditersol1
complex:   clinsol clinsol1 clinsolx clinsolx1 clinsolx2 citersol citersol1
complex16: zlinsol zlinsol1 zlinsolx zlinsolx1 zlinsolx2 zitersol zitersol1

slinsol: $(SLINEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SLINEXM) $(LIBS) -lm -o $@

slinsol1: $(SLINEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SLINEXM1) $(LIBS) -lm -o $@

slinsolx: $(SLINXEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SLINXEXM) $(LIBS) -lm -o $@

slinsolx1: $(SLINXEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SLINXEXM1) $(LIBS) -lm -o $@

slinsolx2: $(SLINXEXM2) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SLINXEXM2) $(LIBS) -lm -o $@

sitersol: $(SITSOL) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SITSOL) $(LIBS) -lm -o $@

sitersol1: $(SITSOL1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SITSOL1) $(LIBS) -lm -o $@

dlinsol: $(DLINEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(DLINEXM) $(LIBS) -lm -o $@

dlinsol1: $(DLINEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(DLINEXM1) $(LIBS) -lm -o $@

dlinsolx: $(DLINXEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(DLINXEXM) $(LIBS) -lm -o $@

dlinsolx1: $(DLINXEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(DLINXEXM1) $(LIBS) -lm -o $@

dlinsolx2: $(DLINXEXM2) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(DLINXEXM2) $(LIBS) -lm -o $@

superlu: $(SUPERLUEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(SUPERLUEXM) $(LIBS) -lm -o $@

ditersol: $(DITSOL) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(DITSOL) $(LIBS) -lm -o $@

ditersol1: $(DITSOL1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(DITSOL1) $(LIBS) -lm -o $@

clinsol: $(CLINEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(CLINEXM) $(LIBS) -lm -o $@

clinsol1: $(CLINEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(CLINEXM1) $(LIBS) -lm -o $@

clinsolx: $(CLINXEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(CLINXEXM) $(LIBS) -lm -o $@

clinsolx1: $(CLINXEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(CLINXEXM1) $(LIBS) -lm -o $@

clinsolx2: $(CLINXEXM2) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(CLINXEXM2) $(LIBS) -lm -o $@

citersol: $(CITSOL) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(CITSOL) $(LIBS) -lm -o $@

citersol1: $(CITSOL1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(CITSOL1) $(LIBS) -lm -o $@

zlinsol: $(ZLINEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(ZLINEXM) $(LIBS) -lm -o $@

zlinsol1: $(ZLINEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(ZLINEXM1) $(LIBS) -lm -o $@

zlinsolx: $(ZLINXEXM) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(ZLINXEXM) $(LIBS) -lm -o $@

zlinsolx1: $(ZLINXEXM1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(ZLINXEXM1) $(LIBS) -lm -o $@

zlinsolx2: $(ZLINXEXM2) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(ZLINXEXM2) $(LIBS) -lm -o $@

zitersol: $(ZITSOL) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(ZITSOL) $(LIBS) -lm -o $@

zitersol1: $(ZITSOL1) $(SUPERLULIB)
	$(LOADER) $(LOADOPTS) $(ZITSOL1) $(LIBS) -lm -o $@

.c.o:
	$(CC) $(CFLAGS) $(CDEFS) -I$(HEADER) -c $< $(VERBOSE)

.f.o:
	$(FORTRAN) $(FFLAGS) -c $< $(VERBOSE)

clean:	
	rm -f *.o *linsol *linsol1 *linsolx *linsolx1 *linsolx2 \
	    superlu *itersol

=== FORTRAN/Makefile ===
include ../make.inc

#######################################################################
#  This makefile creates the Fortran example interface to use the
#  C routines in SuperLU.
#######################################################################

HEADER   = ../SRC
LIBS	= $(SUPERLULIB) $(BLASLIB) -lm

# double real
F77EXM	= f77_main.o hbcode1.o c_fortran_dgssv.o

# double complex
ZF77EXM	= z_f77_main.o zhbcode1.o c_fortran_zgssv.o

all:	f77exm zf77exm

f77exm: $(F77EXM) $(SUPERLULIB)
	$(FORTRAN) $(LOADOPTS) $(F77EXM) $(LIBS) -o $@

zf77exm: $(ZF77EXM) $(SUPERLULIB)
	$(FORTRAN) $(LOADOPTS) $(ZF77EXM) $(LIBS) -o $@

c_fortran_zgssv.o: c_fortran_zgssv.c
	$(CC) $(CFLAGS) $(CDEFS) -I$(HEADER) -c $< $(VERBOSE)

.c.o:
	$(CC) $(CFLAGS) $(CDEFS) -I$(HEADER) -c $< $(VERBOSE)

.f.o:
	$(FORTRAN) $(FFLAGS) -c $< $(VERBOSE)

clean:	
	rm -f *.o f77exm zf77exm

=== MATLAB/Makefile ===
include ../make.inc

LUSRC   = ../SRC
HEADER	= -I$(LUSRC) -I$(MATLAB)/extern/include 
#
# For Matlab Version 4 compatibility: comment out -DV5, add -V4 in FLAGS
FLAGS   = -O -largeArrayDims

all:            mexlusolve mexsuperlu

mexlusolve:	mexlusolve.c $(SUPERLULIB)
		${MATLAB}/bin/mex $(HEADER) ${FLAGS} mexlusolve.c \
		$(SUPERLULIB) $(BLASLIB) -lm

mexsuperlu:	mexsuperlu.c $(SUPERLULIB)
		${MATLAB}/bin/mex $(HEADER) ${FLAGS} mexsuperlu.c \
		$(SUPERLULIB) $(BLASLIB) -lm

clean:	
	rm -f *.o *.mex*

=== SRC/Makefile ===
# makefile for sparse supernodal LU, implemented in ANSI C
include ../make.inc

#######################################################################
#  This is the makefile to create a library for SuperLU.
#  The files are organized as follows:
#
#       ALLAUX -- Auxiliary routines called from all precisions of SuperLU
#	LAAUX  -- LAPACK auxiliary routines called from all precisions
#	SLASRC -- LAPACK single precision real routines
#	DLASRC -- LAPACK double precision real routines
#	CLASRC -- LAPACK single precision complex routines
#	ZLASRC -- LAPACK double precision complex routines
#       SCLAUX -- LAPACK Auxiliary routines called from both real and complex
#       DZLAUX -- LAPACK Auxiliary routines called from both double precision
#                 and complex*16
#	SLUSRC -- Single precision real SuperLU routines
#       DLUSRC -- Double precision real SuperLU routines
#	CLUSRC -- Single precision complex SuperLU routines
#       ZLUSRC -- Double precision complex SuperLU routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  To create or add to the library, enter make
#  followed by one or more of the precisions desired.  Some examples:
#       make single
#       make single double
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#  The library is called
#       superlu.a
#  and is created at the next higher directory level.
#
#  To remove the object files after the library is created, enter
#       make clean
#
#######################################################################

### LAPACK 
LAAUX 	= lsame.o xerbla.o
SLASRC 	= slacon.o 
DLASRC	= dlacon.o
CLASRC	= clacon.o scsum1.o icmax1.o
ZLASRC	= zlacon.o dzsum1.o izmax1.o
SCLAUX 	= slamch.o
DZLAUX 	= dlamch.o

### SuperLU 
ALLAUX 	= superlu_timer.o util.o memory.o get_perm_c.o mmd.o \
	  sp_coletree.o sp_preorder.o sp_ienv.o relax_snode.o \
	  heap_relax_snode.o colamd.o \
	  ilu_relax_snode.o ilu_heap_relax_snode.o mark_relax.o \
	  mc64ad.o qselect.o

SLUSRC = \
	sgssv.o sgssvx.o \
	ssp_blas2.o ssp_blas3.o sgscon.o  \
	slangs.o sgsequ.o slaqgs.o spivotgrowth.o \
	sgsrfs.o sgstrf.o sgstrs.o scopy_to_ucol.o \
	ssnode_dfs.o ssnode_bmod.o \
	spanel_dfs.o spanel_bmod.o \
	sreadhb.o sreadrb.o sreadtriple.o \
	scolumn_dfs.o scolumn_bmod.o spivotL.o spruneL.o \
	smemory.o sutil.o smyblas2.o \
	sgsisx.o sgsitrf.o sldperm.o \
	ilu_sdrop_row.o ilu_ssnode_dfs.o \
	ilu_scolumn_dfs.o ilu_spanel_dfs.o ilu_scopy_to_ucol.o \
	ilu_spivotL.o sdiagonal.o

DLUSRC = \
	dgssv.o dgssvx.o \
	dsp_blas2.o dsp_blas3.o dgscon.o \
	dlangs.o dgsequ.o dlaqgs.o dpivotgrowth.o  \
	dgsrfs.o dgstrf.o dgstrs.o dcopy_to_ucol.o \
	dsnode_dfs.o dsnode_bmod.o dpanel_dfs.o dpanel_bmod.o \
	dreadhb.o dreadrb.o dreadtriple.o \
	dcolumn_dfs.o dcolumn_bmod.o dpivotL.o dpruneL.o \
	dmemory.o dutil.o dmyblas2.o \
	dgsisx.o dgsitrf.o dldperm.o \
	ilu_ddrop_row.o ilu_dsnode_dfs.o \
	ilu_dcolumn_dfs.o ilu_dpanel_dfs.o ilu_dcopy_to_ucol.o \
	ilu_dpivotL.o ddiagonal.o 
        ## dgstrsL.o dgstrsU.o

CLUSRC = \
	scomplex.o cgssv.o cgssvx.o csp_blas2.o csp_blas3.o cgscon.o \
	clangs.o cgsequ.o claqgs.o cpivotgrowth.o  \
	cgsrfs.o cgstrf.o cgstrs.o ccopy_to_ucol.o \
	csnode_dfs.o csnode_bmod.o \
	cpanel_dfs.o cpanel_bmod.o \
	creadhb.o creadrb.o creadtriple.o \
	ccolumn_dfs.o ccolumn_bmod.o cpivotL.o cpruneL.o \
	cmemory.o cutil.o cmyblas2.o \
	cgsisx.o cgsitrf.o cldperm.o \
	ilu_cdrop_row.o ilu_csnode_dfs.o \
	ilu_ccolumn_dfs.o ilu_cpanel_dfs.o ilu_ccopy_to_ucol.o \
	ilu_cpivotL.o cdiagonal.o

ZLUSRC = \
	dcomplex.o zgssv.o zgssvx.o zsp_blas2.o zsp_blas3.o zgscon.o \
	zlangs.o zgsequ.o zlaqgs.o zpivotgrowth.o  \
	zgsrfs.o zgstrf.o zgstrs.o zcopy_to_ucol.o \
	zsnode_dfs.o zsnode_bmod.o \
	zpanel_dfs.o zpanel_bmod.o \
	zreadhb.o zreadrb.o zreadtriple.o \
	zcolumn_dfs.o zcolumn_bmod.o zpivotL.o zpruneL.o \
	zmemory.o zutil.o zmyblas2.o \
	zgsisx.o zgsitrf.o zldperm.o \
	ilu_zdrop_row.o ilu_zsnode_dfs.o \
	ilu_zcolumn_dfs.o ilu_zpanel_dfs.o ilu_zcopy_to_ucol.o \
	ilu_zpivotL.o zdiagonal.o

all:    single double complex complex16

single: $(SLUSRC) $(ALLAUX) $(LAAUX) $(SLASRC) $(SCLAUX)
	$(ARCH) $(ARCHFLAGS) $(SUPERLULIB) \
		$(SLUSRC) $(ALLAUX) $(LAAUX) $(SLASRC) $(SCLAUX)
	$(RANLIB) $(SUPERLULIB)

double: $(DLUSRC) $(ALLAUX) $(LAAUX) $(DLASRC) $(DZLAUX)
	$(ARCH) $(ARCHFLAGS) $(SUPERLULIB) \
                $(DLUSRC) $(ALLAUX) $(LAAUX) $(DLASRC) $(DZLAUX)
	$(RANLIB) $(SUPERLULIB)

complex: $(CLUSRC) $(ALLAUX) $(LAAUX) $(CLASRC) $(SCLAUX)
	$(ARCH) $(ARCHFLAGS) $(SUPERLULIB) \
		$(CLUSRC) $(ALLAUX) $(LAAUX) $(CLASRC) $(SCLAUX)
	$(RANLIB) $(SUPERLULIB)

complex16: $(ZLUSRC) $(ALLAUX) $(LAAUX) $(ZLASRC) $(DZLAUX)
	$(ARCH) $(ARCHFLAGS) $(SUPERLULIB) \
		$(ZLUSRC) $(ALLAUX) $(LAAUX) $(ZLASRC) $(DZLAUX)
	$(RANLIB) $(SUPERLULIB)


##################################
# Do not optimize these routines #
##################################
slamch.o: slamch.c ; $(CC) -c $(NOOPTS) $(CDEFS) $<
dlamch.o: dlamch.c ; $(CC) -c $(NOOPTS) $(CDEFS) $<
superlu_timer.o:  superlu_timer.c ; $(CC) -c $(NOOPTS) $<
##################################

.c.o:
	$(CC) $(CFLAGS) $(CDEFS) $(BLASDEF) -c $< $(VERBOSE)

.f.o:
	$(FORTRAN) $(FFLAGS) -c $<

clean:	
	rm -f *.o $(SUPERLULIB)

=== TESTING/Makefile ===
include ../make.inc

#######################################################################
#  This makefile creates the test programs for the linear equation
#  routines in SuperLU.  The test files are grouped as follows:
#
#       ALINTST -- Auxiliary test routines
#       SLINTST -- Single precision real test routines
#       DLINTST -- Double precision real test routines
#       CLINTST -- Double precision complex test routines
#       ZLINTST -- Double precision complex test routines
#
#  Test programs can be generated for all or some of the four different
#  precisions.  Enter make followed by one or more of the data types
#  desired.  Some examples:
#       make single
#       make single double
#  Alternatively, the command
#       make
#  without any arguments creates all four test programs.
#  The executable files are called
#       stest
#       dtest
#       ctest
#       ztest
#
#  To remove the object files after the executable files have been
#  created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
#######################################################################

HEADER  = ../SRC

ALINTST = sp_ienv.o

SLINTST = sdrive.o sp_sconvert.o sgst01.o sgst02.o sgst04.o sgst07.o 

DLINTST = ddrive.o sp_dconvert.o dgst01.o dgst02.o dgst04.o dgst07.o 

CLINTST = cdrive.o sp_cconvert.o cgst01.o cgst02.o cgst04.o cgst07.o

ZLINTST = zdrive.o sp_zconvert.o zgst01.o zgst02.o zgst04.o zgst07.o

all: testmat single double complex complex16

testmat:
	(cd MATGEN; $(MAKE))

single: ./stest stest.out

./stest: $(SLINTST) $(ALINTST) $(SUPERLULIB) $(TMGLIB)
	$(LOADER) $(LOADOPTS) $(SLINTST) $(ALINTST) \
        $(TMGLIB) $(SUPERLULIB) $(BLASLIB) -lm -o $@

stest.out: stest stest.csh
	@echo Testing SINGLE PRECISION linear equation routines 
	csh stest.csh

double: ./dtest dtest.out

./dtest: $(DLINTST) $(ALINTST) $(SUPERLULIB) $(TMGLIB)
	$(LOADER) $(LOADOPTS) $(DLINTST) $(ALINTST) \
        $(TMGLIB) $(SUPERLULIB) $(BLASLIB) -lm -o $@

dtest.out: dtest dtest.csh
	@echo Testing DOUBLE PRECISION linear equation routines 
	csh dtest.csh

complex: ./ctest ctest.out

./ctest: $(CLINTST) $(ALINTST) $(SUPERLULIB) $(TMGLIB)
	$(LOADER) $(LOADOPTS) $(CLINTST) $(ALINTST) \
	$(TMGLIB) $(SUPERLULIB) $(BLASLIB) -lm -o $@

ctest.out: ctest ctest.csh
	@echo Testing SINGLE COMPLEX linear equation routines 
	csh ctest.csh

complex16: ./ztest ztest.out

./ztest: $(ZLINTST) $(ALINTST) $(SUPERLULIB) $(TMGLIB)
	$(LOADER) $(LOADOPTS) $(ZLINTST) $(ALINTST) \
	$(TMGLIB) $(SUPERLULIB) $(BLASLIB) -lm -o $@

ztest.out: ztest ztest.csh
	@echo Testing DOUBLE COMPLEX linear equation routines 
	csh ztest.csh

##################################
# Do not optimize this routine   #
##################################
dlamch.o: dlamch.c ; $(CC) -c $<

timer.o:  timer.c ; $(CC) -O -c $<

.c.o:
	$(CC) $(CFLAGS) $(CDEFS) -I$(HEADER) -c $< $(VERBOSE)

clean:	
	rm -f *.o *test *.out

=== TESTING/MATGEN/Makefile ===
include ../../make.inc

#######################################################################
#  This is the makefile to create a library of the test matrix
#  generators used in LAPACK.  The files are organized as follows:
#
#     SCATGEN  -- Auxiliary routines called from both REAL and COMPLEX
#     DZATGEN  -- Auxiliary routines called from both DOUBLE PRECISION
#                 and COMPLEX*16
#     SMATGEN  -- Single precision real matrix generation routines
#     CMATGEN  -- Single precision complex matrix generation routines
#     DMATGEN  -- Double precision real matrix generation routines
#     ZMATGEN  -- Double precision complex matrix generation routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  To create or add to the library, enter make
#  followed by one or more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#  The library is called
#       libtmglib.a
#  and is created at the LAPACK directory level.
#
#  To remove the object files after the library is created, enter
#       make clean
#
#######################################################################
ALLAUX  = lsamen.o

SCATGEN = slatm1.o slaran.o slarnd.o slaruv.o slabad.o slarnv.o
SLASRC  = slatb4.o slaset.o slartg.o
SMATGEN = slatms.o slatme.o slatmr.o \
	  slagge.o slagsy.o slarge.o slaror.o slarot.o slatm2.o slatm3.o
SINTRINSIC  = r_lg10.o r_sign.o pow_dd.o

DZATGEN = dlatm1.o dlaran.o dlarnd.o dlaruv.o dlabad.o dlarnv.o
DLASRC  = dlatb4.o dlaset.o dlartg.o
DMATGEN = dlatms.o dlatme.o dlatmr.o \
	  dlagge.o dlagsy.o dlarge.o dlaror.o dlarot.o dlatm2.o dlatm3.o
DINTRINSIC  = d_lg10.o d_sign.o pow_dd.o

CLASRC  = clatb4.o claset.o clartg.o clarnv.o clacgv.o csymv.o
CMATGEN = clatms.o clatme.o clatmr.o \
	  clagge.o clagsy.o clarge.o claror.o clarot.o clatm2.o clatm3.o \
	  claghe.o clarnd.o cdotc.o

ZLASRC  = zlatb4.o zlaset.o zlartg.o zlarnv.o zlacgv.o zsymv.o
ZMATGEN = zlatms.o zlatme.o zlatmr.o \
	  zlagge.o zlagsy.o zlarge.o zlaror.o zlarot.o zlatm2.o zlatm3.o \
	  zlaghe.o zlarnd.o zdotc.o

all: single double complex complex16

single: $(SMATGEN) $(SCATGEN) $(SLASRC) $(SINTRINSIC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(TMGLIB) $(SMATGEN) $(SCATGEN) \
	        $(SLASRC) $(SINTRINSIC) $(ALLAUX)
	$(RANLIB) ../$(TMGLIB)

double: $(DMATGEN) $(DZATGEN) $(DLASRC) $(DINTRINSIC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(TMGLIB) $(DMATGEN) $(DZATGEN) \
	        $(DLASRC) $(DINTRINSIC) $(ALLAUX)
	$(RANLIB) ../$(TMGLIB)

complex: $(CMATGEN) $(SCATGEN) $(CLASRC) $(SINTRINSIC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(TMGLIB) $(CMATGEN) $(SCATGEN) \
	        $(CLASRC) $(SINTRINSIC) $(ALLAUX)
	$(RANLIB) ../$(TMGLIB)

complex16: $(ZMATGEN) $(DZATGEN) $(ZLASRC) $(DINSTRINSIC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(TMGLIB) $(ZMATGEN) $(DZATGEN) \
	        $(ZLASRC) $(DINTRINSIC) $(ALLAUX)
	$(RANLIB) ../$(TMGLIB)

clean:
	rm -f *.o ../$(TMGLIB)

.c.o: ; $(CC) $(CFLAGS) $(CDEFS) -c $<

=== debian/changelog ===
superlu (4.3+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 26 Feb 2014 18:18:37 +0100

superlu (4.3+dfsg-2) experimental; urgency=medium

  * Team upload.
  * Fix FTBFS in parallel mode.
  * Multi-archify the package.

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 22 Dec 2013 21:46:26 +0100

superlu (4.3+dfsg-1) experimental; urgency=medium

  * Team upload.

  [ Sébastien Villemot ]
  * Repackage the upstream tarball to remove non-free code (mc64{a,i}d
    functions)
  * As a consequence, provide stubs for these functions in no-mc64ad.patch:
    if the removed functionality is used, the library will simply abort.
  * Rename development package as libsuperlu-dev, as requested by ftpmasters.
  * Document the removed functionality in README.Debian.
  * debian/copyright: rewrite using machine-readable format 1.0.
  * Use new scheme for BLAS dependencies.
  * Remove the broken infrastructure for running tests from /usr/share/doc.
  * Add new libsuperlu-doc package.
  * debian/control: updated Standards-Version to 3.9.5
  
  [ Christophe Trophime ]
  * New upstream release (Closes: #709165)
  * debian/rules: 
     - switch to debhelper
     - simplify rules
  * Add patch format-security.patch
  * Add patch Makefile.patch
  * Convert to 3.0 (quilt) source format

  [ Daniel Leidert ]
  * debian/control: Added Homepage field.
    (Vcs-Svn): Fixed.
    (Depends): ${Source-Version} is deprecated (make the package binNMU safe).
  * debian/dirs: Dropped.
  * debian/rules (clean): Fixed debian-rules-ignores-make-clean-error.

  [ Christophe Prud'homme ]
  * New upstream release (4.0)
  * Fixed all lintian warnings

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 07 Dec 2013 14:31:50 +0100

superlu (3.0+20070106-3) unstable; urgency=low

  * debian/control: changed XS-Vcs-*  to Vcs-*
  * Bug fix: "superlu: Please depend on libblas instead of refblas3",
    thanks to Colin Tuckley (Closes: #462290).

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 22 Feb 2008 23:54:05 +0100

superlu (3.0+20070106-2) unstable; urgency=low

  [Christophe Prud'homme]
  * debian/control: update Standards-Version, no change
  * Bug fix: "superlu: Please depend on libblas instead of refblas3",
    thanks to Colin Tuckley (Closes: #462290).

 -- Christophe Prud'homme <prudhomm@debian.org>  Thu, 24 Jan 2008 10:22:42 +0100

superlu (3.0+20070106-1) unstable; urgency=low

  [ Rafael Laboissiere ]
  * debian/control: Added XS-Vcs-Svn and XS-Vcs-Browser fields to the Source
    section

  [Christophe Prud'homme]
  * New upstream release

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 15 Jul 2007 10:00:50 +0200

superlu (3.0-5) unstable; urgency=low

  * Reverted libsuperlu3-dev to libsuperlu-dev

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri,  7 Apr 2006 10:24:43 +0200

superlu (3.0-4) unstable; urgency=low

  * Changed libsuperlu3-dev to libsuperlu-dev

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri,  7 Apr 2006 10:01:06 +0200

superlu (3.0-3) unstable; urgency=low

  * Changed prudhomm@mit.edu  to prudhomm@debian.org
  * Use pkg-scicomp-devel@lists.alioth.debian.org as new maintainer address

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri,  7 Apr 2006 09:49:25 +0200

superlu (3.0-2) unstable; urgency=low

  * fixed inconsistencies: libsuperlu3-dev vs libsuperlu-dev

 -- Christophe Prud'homme <prudhomm@mit.edu>  Wed, 18 Aug 2004 09:26:10 +0200

superlu (3.0-1) unstable; urgency=low

  * Initial Release. (closes: #265217)

 -- Christophe Prud'homme <prudhomm@mit.edu>  Thu, 12 Aug 2004 11:05:16 +0200

=== debian/control ===
Source: superlu
Priority: optional
Section: devel
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>
Build-Depends: debhelper (>= 9), gcc (>= 3.0), csh, libblas-dev | libblas.so,
               dh-exec
Standards-Version: 3.9.5
Homepage: http://crd-legacy.lbl.gov/~xiaoye/SuperLU/
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/superlu/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/superlu/trunk

Package: libsuperlu4
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Direct solution of large, sparse systems of linear equations
 SuperLU is a general purpose library for the direct solution of
 large, sparse, nonsymmetric systems of linear equations on high
 performance machines. The library is written in C and is callable from
 either C or Fortran. The library routines will perform an LU
 decomposition with partial pivoting and triangular system solves
 through forward and back substitution. The LU factorization routines
 can handle non-square matrices but the triangular solves are performed
 only for square matrices. The matrix columns may be preordered (before
 factorization) either through library or user supplied routines. This
 preordering for sparsity is completely separate from the
 factorization. Working precision iterative refinement subroutines are
 provided for improved backward stability. Routines are also provided
 to equilibrate the system, estimate the condition number, calculate
 the relative backward error, and estimate error bounds for the refined
 solutions.

Package: libsuperlu-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsuperlu4 (= ${binary:Version}), libblas-dev, ${misc:Depends}
Suggests: libsuperlu-doc
Conflicts: libsuperlu3-dev
Description: Direct solution of large, sparse systems of linear equations
 Development files for SuperLU.
 .
 SuperLU is a general purpose library for the direct solution of
 large, sparse, nonsymmetric systems of linear equations on high
 performance machines. The library is written in C and is callable from
 either C or Fortran. The library routines will perform an LU
 decomposition with partial pivoting and triangular system solves
 through forward and back substitution. The LU factorization routines
 can handle non-square matrices but the triangular solves are performed
 only for square matrices. The matrix columns may be preordered (before
 factorization) either through library or user supplied routines. This
 preordering for sparsity is completely separate from the
 factorization. Working precision iterative refinement subroutines are
 provided for improved backward stability. Routines are also provided
 to equilibrate the system, estimate the condition number, calculate
 the relative backward error, and estimate error bounds for the refined
 solutions.

Package: libsuperlu4-dbg
Priority: extra
Section: debug
Architecture: any
Multi-Arch: same
Depends: libsuperlu4 (= ${binary:Version}), ${misc:Depends}
Description: Direct solution of large, sparse systems of linear equations
 Debug files for SuperLU.
 .
 SuperLU is a general purpose library for the direct solution of
 large, sparse, nonsymmetric systems of linear equations on high
 performance machines. The library is written in C and is callable from
 either C or Fortran. The library routines will perform an LU
 decomposition with partial pivoting and triangular system solves
 through forward and back substitution. The LU factorization routines
 can handle non-square matrices but the triangular solves are performed
 only for square matrices. The matrix columns may be preordered (before
 factorization) either through library or user supplied routines. This
 preordering for sparsity is completely separate from the
 factorization. Working precision iterative refinement subroutines are
 provided for improved backward stability. Routines are also provided
 to equilibrate the system, estimate the condition number, calculate
 the relative backward error, and estimate error bounds for the refined
 solutions.

Package: libsuperlu-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation for SuperLU
 This package contains the user guide and the reference manual of SuperLU.
 It also includes some example programs.

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
http://crd-legacy.lbl.gov/~xiaoye/SuperLU/superlu_(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))

## superlu 5.1

=== CMakeLists.txt ===
######################################################################
#
# CMakeLists.txt for SUPERLU
#
######################################################################

# Required version
cmake_minimum_required(VERSION 2.8.12)

# Project Version	
project(SuperLU C)
set(VERSION_MAJOR "5")
set(VERSION_MINOR "0")
set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR})

######################################################################
#
# IDEAS: xSDK standards module
MESSAGE("\nProcess XSDK defaults ...")
INCLUDE("XSDKDefaults.cmake")
######################################################################

######################################################################
#
# Usual initialization stuff
#
######################################################################
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)    ## ????

enable_language (Fortran)
# set(NOFORTRAN TRUE)
set(NOFORTRAN FALSE)
set(SUPERLU_VERSION "${PROJECT_VERSION}")
set(SUPERLU_REV "${PROJECT_REV}")

# setup options
option(enable_blaslib   "Build the CBLAS library" OFF)
option(enable_matlabmex "Build the Matlab mex library" OFF)
option(enable_tests     "Build tests" ON)
option(enable_doc       "Build doxygen documentation" OFF)
option(enable_single    "Enable single precision library" ON)
option(enable_double    "Enable double precision library" ON)
option(enable_complex   "Enable complex precision library" ON)
option(enable_complex16 "Enable complex16 precision library" ON)
option(enable_examples  "Build examples" ON)

# setup required compiler defines and options.
## add_definitions(-DPRNTlevel=0 -DAdd_)
## get_directory_property( DirDefs COMPILE_DEFINITIONS )
set(CMAKE_C_FLAGS "-DPRNTlevel=0 -DAdd_")
set(CMAKE_C_FLAGS_RELEASE "-O3")

######################################################################
#
# Find packages
#
######################################################################

if(NOT enable_blaslib)
  find_package(BLAS)
endif()

if(BLAS_FOUND)
  add_definitions(-DPRNTlevel=0 -DUSE_VENDOR_BLAS)
  set(BLAS_LIB ${BLAS_LIBRARIES})
else()
  add_subdirectory(CBLAS)
  set(BLAS_LIB blas)
endif()

######################################################################
#
# Include directories
#
######################################################################

include_directories(${CMAKE_SOURCE_DIR}/SRC)

######################################################################
#
# Add subdirectories
#
######################################################################

add_subdirectory(SRC)

if(enable_matlabmex)
  add_subdirectory(MATLAB)
endif()

if(enable_tests)
  enable_testing()
  add_subdirectory(TESTING)
endif()

if(enable_doc)
  message(FATAL_ERROR "Documentation build requested but not implemented.")
  #implement doxygen
endif()

if(enable_examples)
  add_subdirectory(EXAMPLE)
endif()


# file(WRITE "make.defs" "# can be exposed to users"
#  ${CMAKE_C_COMPILER}  )
string (REPLACE ";" " " BLAS_LIB_STR "${BLAS_LIB}")
# configure_file(${CMAKE_SOURCE_DIR}/make.inc.in ${CMAKE_BINARY_DIR}/make.inc)
configure_file(${SuperLU_SOURCE_DIR}/make.inc.in ${SuperLU_SOURCE_DIR}/make.inc)

=== EXAMPLE/CMakeLists.txt ===

if(enable_single)
  set(SLINEXM slinsol.c)

  add_executable(slinsol ${SLINEXM})
  target_link_libraries(slinsol superlu_${VERSION_MAJOR}.${VERSION_MINOR} ${BLAS_LIB} m)
endif()

=== SRC/CMakeLists.txt ===

set(headers supermatrix.h)

set(sources
  superlu_timer.c
  util.c
  memory.c
  get_perm_c.c
  mmd.c
  sp_coletree.c
  sp_preorder.c
  sp_ienv.c
  relax_snode.c
  heap_relax_snode.c
  colamd.c
  ilu_relax_snode.c
  ilu_heap_relax_snode.c
  mark_relax.c
  mc64ad.c
  qselect.c
  input_error.c
)
set_source_files_properties(superlu_timer.c PROPERTIES COMPILE_FLAGS -O0)

if(enable_single)
  list(APPEND headers
    slu_sdefs.h
  )

  list(APPEND sources
    slacon2.c
    smach.c
    sgssv.c
    sgssvx.c
    ssp_blas2.c
    ssp_blas3.c
    sgscon.c
    slangs.c
    sgsequ.c
    slaqgs.c
    spivotgrowth.c
    sgsrfs.c
    sgstrf.c
    sgstrs.c
    scopy_to_ucol.c
    ssnode_dfs.c
    ssnode_bmod.c
    spanel_dfs.c
    spanel_bmod.c
    sreadhb.c
    sreadrb.c
    sreadtriple.c
    scolumn_dfs.c
    scolumn_bmod.c
    spivotL.c
    spruneL.c
    smemory.c
    sutil.c
    smyblas2.c
    sgsisx.c
    sgsitrf.c
    sldperm.c
    ilu_sdrop_row.c
    ilu_ssnode_dfs.c
    ilu_scolumn_dfs.c
    ilu_spanel_dfs.c
    ilu_scopy_to_ucol.c
    ilu_spivotL.c
    sdiagonal.c
  )
  set_source_files_properties(smach.c PROPERTIES COMPILE_FLAGS -O0)
endif()

if(enable_double)
  list(APPEND headers
    slu_ddefs.h
  )

  list(APPEND sources
    dlacon2.c
    dmach.c
    dgssv.c
    dgssvx.c
    dsp_blas2.c
    dsp_blas3.c
    dgscon.c
    dlangs.c
    dgsequ.c
    dlaqgs.c
    dpivotgrowth.c
    dgsrfs.c
    dgstrf.c
    dgstrs.c
    dcopy_to_ucol.c
    dsnode_dfs.c
    dsnode_bmod.c
    dpanel_dfs.c
    dpanel_bmod.c
    dreadhb.c
    dreadrb.c
    dreadtriple.c
    dcolumn_dfs.c
    dcolumn_bmod.c
    dpivotL.c
    dpruneL.c
    dmemory.c
    dutil.c
    dmyblas2.c
    dgsisx.c
    dgsitrf.c
    dldperm.c
    ilu_ddrop_row.c
    ilu_dsnode_dfs.c
    ilu_dcolumn_dfs.c
    ilu_dpanel_dfs.c
    ilu_dcopy_to_ucol.c
    ilu_dpivotL.c
    ddiagonal.c
  )
  set_source_files_properties(dmach.c PROPERTIES COMPILE_FLAGS -O0)
endif()

if(enable_complex)
  list(APPEND headers
    slu_cdefs.h
  )

  list(APPEND sources
    clacon2.c
    scsum1.c
    icmax1.c
    scomplex.c
    cgssv.c
    cgssvx.c
    csp_blas2.c
    csp_blas3.c
    cgscon.c
    clangs.c
    cgsequ.c
    claqgs.c
    cpivotgrowth.c
    cgsrfs.c
    cgstrf.c
    cgstrs.c
    ccopy_to_ucol.c
    csnode_dfs.c
    csnode_bmod.c
    cpanel_dfs.c
    cpanel_bmod.c
    creadhb.c
    creadrb.c
    creadtriple.c
    ccolumn_dfs.c
    ccolumn_bmod.c
    cpivotL.c
    cpruneL.c
    cmemory.c
    cutil.c
    cmyblas2.c
    cgsisx.c
    cgsitrf.c
    cldperm.c
    ilu_cdrop_row.c
    ilu_csnode_dfs.c
    ilu_ccolumn_dfs.c
    ilu_cpanel_dfs.c
    ilu_ccopy_to_ucol.c
    ilu_cpivotL.c
    cdiagonal.c
  )
endif()

if(enable_complex16)
  list(APPEND headers
    slu_zdefs.h
  )

  list(APPEND sources
    zlacon2.c
    dzsum1.c
    izmax1.c
    dcomplex.c
    zgssv.c
    zgssvx.c
    zsp_blas2.c
    zsp_blas3.c
    zgscon.c
    zlangs.c
    zgsequ.c
    zlaqgs.c
    zpivotgrowth.c
    zgsrfs.c
    zgstrf.c
    zgstrs.c
    zcopy_to_ucol.c
    zsnode_dfs.c
    zsnode_bmod.c
    zpanel_dfs.c
    zpanel_bmod.c
    zreadhb.c
    zreadrb.c
    zreadtriple.c
    zcolumn_dfs.c
    zcolumn_bmod.c
    zpivotL.c
    zpruneL.c
    zmemory.c
    zutil.c
    zmyblas2.c
    zgsisx.c
    zgsitrf.c
    zldperm.c
    ilu_zdrop_row.c
    ilu_zsnode_dfs.c
    ilu_zcolumn_dfs.c
    ilu_zpanel_dfs.c
    ilu_zcopy_to_ucol.c
    ilu_zpivotL.c
    zdiagonal.c
  )
endif()

add_library(superlu_${VERSION_MAJOR}.${VERSION_MINOR} ${sources} ${HEADERS})

install(TARGETS superlu_${VERSION_MAJOR}.${VERSION_MINOR}
  DESTINATION ${CMAKE_INSTALL_PREFIX}/lib
)

install(FILES ${headers}
  DESTINATION ${CMAKE_INSTALL_PREFIX}/include
)

=== TESTING/CMakeLists.txt ===
include_directories(${SuperLU_SOURCE_DIR}/SRC)
add_subdirectory(MATGEN)

set(ALINTST sp_ienv.c)
set(NVAL   9 19)
set(NRHS   2)
set(LWORK  0 10000000)

function(cat IN_FILE OUT_FILE)
  file(READ ${IN_FILE} CONTENTS)
  file(APPEND ${OUT_FILE} "${CONTENTS}")
endfunction()


macro(add_superlu_test output input target)
  set(TEST_INPUT "${SuperLU_SOURCE_DIR}/EXAMPLE/${input}")
  set(TEST_OUTPUT "${SuperLU_BINARY_DIR}/TESTING/${output}")

  # Prepare a temporary file to "cat" to:
  # "== LAPACK test matrices"
  file(WRITE ${TEST_OUTPUT} "")

  get_target_property(TEST_LOC ${target} LOCATION)

  foreach (n ${NVAL})
    foreach (s ${NRHS})
      foreach(l ${LWORK})
          set(testName "${target}_${n}_${s}_${l}")
	  set(SINGLE_OUTPUT ${SuperLU_BINARY_DIR}/TESTING/${testName}.out)
          add_test( ${testName}_LA  "${CMAKE_COMMAND}"
	    -DTEST=${TEST_LOC} -t "LA" -n ${n} -s ${s} -l ${l}
	    -DOUTPUT=${SINGLE_OUTPUT}
	    -DALL_OUTPUT=${TEST_OUTPUT}
	    -DHEADING=Dense\ matrix\ --\ n=${n},\ s=${s},\ lwork=${l}
	    -P "${SuperLU_SOURCE_DIR}/TESTING/runtest.cmake"
	  )
      endforeach()
    endforeach()
  endforeach()

#  file(APPEND ${TEST_OUTPUT} "== sparse matrix\n")

  foreach (s ${NRHS})
      foreach(l ${LWORK})
          set(testName "${target}_${s}_${l}")
	  set(SINGLE_OUTPUT ${SuperLU_BINARY_DIR}/TESTING/${testName}.out)
          add_test( ${testName}_SP  "${CMAKE_COMMAND}"
	    -DTEST=${TEST_LOC} -t "SP" -s ${s} -l ${l} -f ${TEST_INPUT}
	    -DOUTPUT=${SINGLE_OUTPUT}
	    -DALL_OUTPUT=${TEST_OUTPUT}
	    -DHEADING=Sparse\ matrix\ ${TEST_INPUT}\ --\ s=${s},\ lwork=${l}
	    -P "${SuperLU_SOURCE_DIR}/TESTING/runtest.cmake")
      endforeach()
  endforeach()

endmacro(add_superlu_test)


if(enable_single)
  set(SLINTST sdrive.c sp_sconvert.c sgst01.c sgst02.c sgst04.c sgst07.c)

  add_executable(s_test ${ALINTST} ${SLINTST})
  target_link_libraries(s_test matgen superlu_${VERSION_MAJOR}.${VERSION_MINOR} ${BLAS_LIB} m)

  add_superlu_test(s_test.out g20.rua s_test)

endif()


if(enable_double)
  set(DLINTST ddrive.c sp_dconvert.c dgst01.c dgst02.c dgst04.c dgst07.c)

  add_executable(d_test ${ALINTST} ${DLINTST})
  target_link_libraries(d_test matgen superlu_${VERSION_MAJOR}.${VERSION_MINOR} ${BLAS_LIB} m)

  add_superlu_test(d_test.out g20.rua d_test)
endif()

if(enable_complex)
  set(CLINTST cdrive.c sp_cconvert.c cgst01.c cgst02.c cgst04.c cgst07.c)

  add_executable(c_test ${ALINTST} ${CLINTST})
  target_link_libraries(c_test matgen superlu_${VERSION_MAJOR}.${VERSION_MINOR} ${BLAS_LIB} m)

  add_superlu_test(c_test.out cg20.cua c_test)
endif()


if(enable_complex16)
  set(ZLINTST zdrive.c sp_zconvert.c zgst01.c zgst02.c zgst04.c zgst07.c)

  add_executable(z_test ${ALINTST} ${ZLINTST})
  target_link_libraries(z_test matgen superlu_${VERSION_MAJOR}.${VERSION_MINOR} ${BLAS_LIB} m)

  add_superlu_test(z_test.out cg20.cua z_test)
endif()

=== TESTING/MATGEN/CMakeLists.txt ===
set(sources "")

if(enable_single)
  list(APPEND sources
    slatm1.c
    slaran.c
    slarnd.c
    slaruv.c
    slabad.c
    slarnv.c
    slatb4.c
    slaset.c
    slartg.c
    slatms.c
    slatme.c
    slatmr.c
    slagge.c
    slagsy.c
    slarge.c
    slaror.c
    slarot.c
    slatm2.c
    slatm3.c
    r_lg10.c
    r_sign.c
    pow_dd.c
    pow_ri.c
  )
endif()

if(enable_double)
  list(APPEND sources
    dlatm1.c
    dlaran.c
    dlarnd.c
    dlaruv.c
    dlabad.c
    dlarnv.c
    dlatb4.c
    dlaset.c
    dlartg.c
    dlatms.c
    dlatme.c
    dlatmr.c
    dlagge.c
    dlagsy.c
    dlarge.c
    dlaror.c
    dlarot.c
    dlatm2.c
    dlatm3.c
    d_lg10.c
    d_sign.c
    pow_dd.c
    pow_di.c
  )
endif()

if(enable_complex)
  list(APPEND sources
    clatb4.c
    claset.c
    clartg.c
    clarnv.c
    clacgv.c
    csymv.c
    clatms.c
    clatme.c
    clatmr.c
    clagge.c
    clagsy.c
    clarge.c
    claror.c
    clarot.c
    clatm2.c
    clatm3.c
    claghe.c
    clarnd.c
    cdotc.c
  )
endif()

if(enable_complex16)
  list(APPEND sources
    zlatb4.c
    zlaset.c
    zlartg.c
    zlarnv.c
    zlacgv.c
    zsymv.c
    zlatms.c
    zlatme.c
    zlatmr.c
    zlagge.c
    zlagsy.c
    zlarge.c
    zlaror.c
    zlarot.c
    zlatm2.c
    zlatm3.c
    zlaghe.c
    zlarnd.c
    zdotc.c
  )
endif()

add_library(matgen ${sources})

=== TESTING/MATGEN/Makefile ===
--- 
+++ 
@@ -29,29 +29,30 @@
 #       make clean
 #
 #######################################################################
-ALLAUX  = lsamen.o
 
 SCATGEN = slatm1.o slaran.o slarnd.o slaruv.o slabad.o slarnv.o
 SLASRC  = slatb4.o slaset.o slartg.o
 SMATGEN = slatms.o slatme.o slatmr.o \
 	  slagge.o slagsy.o slarge.o slaror.o slarot.o slatm2.o slatm3.o
-SINTRINSIC  = r_lg10.o r_sign.o pow_dd.o
+SINTRINSIC  = r_lg10.o r_sign.o pow_dd.o pow_ri.o
 
 DZATGEN = dlatm1.o dlaran.o dlarnd.o dlaruv.o dlabad.o dlarnv.o
 DLASRC  = dlatb4.o dlaset.o dlartg.o
 DMATGEN = dlatms.o dlatme.o dlatmr.o \
 	  dlagge.o dlagsy.o dlarge.o dlaror.o dlarot.o dlatm2.o dlatm3.o
-DINTRINSIC  = d_lg10.o d_sign.o pow_dd.o
+DINTRINSIC  = d_lg10.o d_sign.o pow_dd.o pow_di.o
 
 CLASRC  = clatb4.o claset.o clartg.o clarnv.o clacgv.o csymv.o
 CMATGEN = clatms.o clatme.o clatmr.o \
 	  clagge.o clagsy.o clarge.o claror.o clarot.o clatm2.o clatm3.o \
-	  claghe.o clarnd.o cdotc.o
+	  claghe.o clarnd.o
+ #cdotc.o  already in BLAS
 
 ZLASRC  = zlatb4.o zlaset.o zlartg.o zlarnv.o zlacgv.o zsymv.o
 ZMATGEN = zlatms.o zlatme.o zlatmr.o \
 	  zlagge.o zlagsy.o zlarge.o zlaror.o zlarot.o zlatm2.o zlatm3.o \
-	  zlaghe.o zlarnd.o zdotc.o
+	  zlaghe.o zlarnd.o
+ #zdotc.o  in BLAS
 
 all: single double complex complex16

## superlu 5.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,13 +10,15 @@
 # Project Version	
 project(SuperLU C)
 set(VERSION_MAJOR "5")
-set(VERSION_MINOR "0")
-set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR})
+set(VERSION_MINOR "1")
+set(VERSION_BugFix "1")
+set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix})
 
 ######################################################################
 #
 # IDEAS: xSDK standards module
 MESSAGE("\nProcess XSDK defaults ...")
+# SET(USE_XSDK_DEFAULTS_DEFAULT TRUE) # Set to false if desired
 INCLUDE("XSDKDefaults.cmake")
 ######################################################################
 
@@ -27,6 +29,8 @@
 ######################################################################
 SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)    ## ????
 
+# enable_language(C)
+# enable_language(C++)
 enable_language (Fortran)
 # set(NOFORTRAN TRUE)
 set(NOFORTRAN FALSE)
@@ -65,7 +69,7 @@
   set(BLAS_LIB ${BLAS_LIBRARIES})
 else()
   add_subdirectory(CBLAS)
-  set(BLAS_LIB blas)
+  set(BLAS_LIB ${CMAKE_SOURCE_DIR}/build/CBLAS/libblas.a)
 endif()
 
 ######################################################################

=== EXAMPLE/CMakeLists.txt ===

if(enable_single)
  set(SLINEXM slinsol.c)

  add_executable(slinsol ${SLINEXM})
  target_link_libraries(slinsol superlu_${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix} ${BLAS_LIB} m)
endif()

=== SRC/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,11 @@
 
-set(headers supermatrix.h)
+set(headers 
+    supermatrix.h
+    slu_Cnames.h
+    slu_dcomplex.h
+    slu_scomplex.h
+    slu_util.h
+    superlu_enum_consts.h)
 
 set(sources
   superlu_timer.c
@@ -220,9 +226,9 @@
   )
 endif()
 
-add_library(superlu_${VERSION_MAJOR}.${VERSION_MINOR} ${sources} ${HEADERS})
-
-install(TARGETS superlu_${VERSION_MAJOR}.${VERSION_MINOR}
+add_library(superlu_${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix}  ${sources} ${HEADERS})
+
+install(TARGETS superlu_${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix}
   DESTINATION ${CMAKE_INSTALL_PREFIX}/lib
 )

=== TESTING/CMakeLists.txt ===
--- 
+++ 
@@ -60,7 +60,7 @@
   set(SLINTST sdrive.c sp_sconvert.c sgst01.c sgst02.c sgst04.c sgst07.c)
 
   add_executable(s_test ${ALINTST} ${SLINTST})
-  target_link_libraries(s_test matgen superlu_${VERSION_MAJOR}.${VERSION_MINOR} ${BLAS_LIB} m)
+  target_link_libraries(s_test matgen superlu_${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix} ${BLAS_LIB} m)
 
   add_superlu_test(s_test.out g20.rua s_test)
 
@@ -71,7 +71,7 @@
   set(DLINTST ddrive.c sp_dconvert.c dgst01.c dgst02.c dgst04.c dgst07.c)
 
   add_executable(d_test ${ALINTST} ${DLINTST})
-  target_link_libraries(d_test matgen superlu_${VERSION_MAJOR}.${VERSION_MINOR} ${BLAS_LIB} m)
+  target_link_libraries(d_test matgen superlu_${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix}  ${BLAS_LIB} m)
 
   add_superlu_test(d_test.out g20.rua d_test)
 endif()
@@ -80,7 +80,7 @@
   set(CLINTST cdrive.c sp_cconvert.c cgst01.c cgst02.c cgst04.c cgst07.c)
 
   add_executable(c_test ${ALINTST} ${CLINTST})
-  target_link_libraries(c_test matgen superlu_${VERSION_MAJOR}.${VERSION_MINOR} ${BLAS_LIB} m)
+  target_link_libraries(c_test matgen superlu_${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix} ${BLAS_LIB} m)
 
   add_superlu_test(c_test.out cg20.cua c_test)
 endif()
@@ -90,7 +90,7 @@
   set(ZLINTST zdrive.c sp_zconvert.c zgst01.c zgst02.c zgst04.c zgst07.c)
 
   add_executable(z_test ${ALINTST} ${ZLINTST})
-  target_link_libraries(z_test matgen superlu_${VERSION_MAJOR}.${VERSION_MINOR} ${BLAS_LIB} m)
+  target_link_libraries(z_test matgen superlu_${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix} ${BLAS_LIB} m)
 
   add_superlu_test(z_test.out cg20.cua z_test)
 endif()
